/[gentoo-x86]/eclass/haskell-cabal.eclass
Gentoo

Diff of /eclass/haskell-cabal.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.26 Revision 1.30
1# Copyright 1999-2012 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.26 2012/01/20 18:24:09 slyfox Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/haskell-cabal.eclass,v 1.30 2012/04/14 19:30:53 slyfox Exp $
4 4
5# @ECLASS: haskell-cabal.eclass 5# @ECLASS: haskell-cabal.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Haskell herd <haskell@gentoo.org> 7# Haskell herd <haskell@gentoo.org>
8# @AUTHOR: 8# @AUTHOR:
28# bin -- the package installs binaries 28# bin -- the package installs binaries
29# lib -- the package installs libraries 29# lib -- the package installs libraries
30# nocabaldep -- don't add dependency on cabal. 30# nocabaldep -- don't add dependency on cabal.
31# only used for packages that _must_ not pull the dependency 31# only used for packages that _must_ not pull the dependency
32# on cabal, but still use this eclass (e.g. haskell-updater). 32# on cabal, but still use this eclass (e.g. haskell-updater).
33#
34# Dependencies on other cabal packages have to be specified
35# correctly.
36#
37# Cabal libraries should usually be SLOTted with "${PV}".
38#
39# Many Cabal packages require S to be manually set.
40#
41# Conforming Cabal packages don't require any function definitions
42# in the ebuild.
43#
44# Special flags to Cabal Configure can now be set by using
45# CABAL_CONFIGURE_FLAGS
46 33
47inherit ghc-package multilib 34inherit ghc-package multilib
48 35
49# @ECLASS-VARIABLE: CABAL_EXTRA_CONFIGURE_FLAGS 36# @ECLASS-VARIABLE: CABAL_EXTRA_CONFIGURE_FLAGS
50# @DESCRIPTION: 37# @DESCRIPTION:
51# User-specified additional parameters passed to 'setup configure'. 38# User-specified additional parameters passed to 'setup configure'.
52# example: /etc/make.conf: CABAL_EXTRA_CONFIGURE_FLAGS=--enable-shared 39# example: /etc/make.conf: CABAL_EXTRA_CONFIGURE_FLAGS=--enable-shared
53: ${CABAL_EXTRA_CONFIGURE_FLAGS:=} 40: ${CABAL_EXTRA_CONFIGURE_FLAGS:=}
41
42# @ECLASS-VARIABLE: CABAL_EXTRA_BUILD_FLAGS
43# @DESCRIPTION:
44# User-specified additional parameters passed to 'setup build'.
45# example: /etc/make.conf: CABAL_EXTRA_BUILD_FLAGS=-v
46: ${CABAL_EXTRA_BUILD_FLAGS:=}
54 47
55# @ECLASS-VARIABLE: GHC_BOOTSTRAP_FLAGS 48# @ECLASS-VARIABLE: GHC_BOOTSTRAP_FLAGS
56# @DESCRIPTION: 49# @DESCRIPTION:
57# User-specified additional parameters for ghc when building 50# User-specified additional parameters for ghc when building
58# _only_ 'setup' binary bootstrap. 51# _only_ 'setup' binary bootstrap.
87 esac 80 esac
88done 81done
89 82
90if [[ -n "${CABAL_USE_HADDOCK}" ]]; then 83if [[ -n "${CABAL_USE_HADDOCK}" ]]; then
91 IUSE="${IUSE} doc" 84 IUSE="${IUSE} doc"
92 DEPEND="${DEPEND} doc? ( dev-haskell/haddock )" 85 # don't require depend on itself to build docs.
86 # ebuild bootstraps docs from just built binary
87 [[ ${CATEGORY}/${PN} = "dev-haskell/haddock" ]] || DEPEND="${DEPEND} doc? ( dev-haskell/haddock )"
93fi 88fi
94 89
95if [[ -n "${CABAL_USE_HSCOLOUR}" ]]; then 90if [[ -n "${CABAL_USE_HSCOLOUR}" ]]; then
96 IUSE="${IUSE} hscolour" 91 IUSE="${IUSE} hscolour"
97 DEPEND="${DEPEND} hscolour? ( dev-haskell/hscolour )" 92 DEPEND="${DEPEND} hscolour? ( dev-haskell/hscolour )"
155cabal-bootstrap() { 150cabal-bootstrap() {
156 local setupmodule 151 local setupmodule
157 local cabalpackage 152 local cabalpackage
158 if [[ -f "${S}/Setup.lhs" ]]; then 153 if [[ -f "${S}/Setup.lhs" ]]; then
159 setupmodule="${S}/Setup.lhs" 154 setupmodule="${S}/Setup.lhs"
160 else
161 if [[ -f "${S}/Setup.hs" ]]; then 155 elif [[ -f "${S}/Setup.hs" ]]; then
162 setupmodule="${S}/Setup.hs" 156 setupmodule="${S}/Setup.hs"
163 else 157 else
164 die "No Setup.lhs or Setup.hs found" 158 die "No Setup.lhs or Setup.hs found"
165 fi
166 fi 159 fi
167 160
168 # We build the setup program using the latest version of 161 # We build the setup program using the latest version of
169 # cabal that we have installed 162 # cabal that we have installed
170 if version_is_at_least "6.4" "$(ghc-version)"; then
171 cabalpackage=Cabal-$(cabal-version) 163 cabalpackage=Cabal-$(cabal-version)
172 else
173 # older ghc's don't support package versioning
174 cabalpackage=Cabal
175 fi
176 einfo "Using cabal-$(cabal-version)." 164 einfo "Using cabal-$(cabal-version)."
177 165
178 make_setup() { 166 make_setup() {
179 set -- -package "${cabalpackage}" --make "${setupmodule}" \ 167 set -- -package "${cabalpackage}" --make "${setupmodule}" \
180 ${GHC_BOOTSTRAP_FLAGS} \ 168 ${GHC_BOOTSTRAP_FLAGS} \
181 "$@" \ 169 "$@" \
182 -o setup 170 -o setup
183 echo $(ghc-getghc) "$@" 171 echo $(ghc-getghc) ${HCFLAGS} "$@"
184 $(ghc-getghc) "$@" 172 $(ghc-getghc) "$@"
185 } 173 }
186 if $(ghc-supports-shared-libraries); then 174 if $(ghc-supports-shared-libraries); then
187 # some custom build systems might use external libraries, 175 # # some custom build systems might use external libraries,
188 # for which we don't have shared libs, so keep static fallback 176 # # for which we don't have shared libs, so keep static fallback
177 # Disabled '-dynamic' as ghc does not embed RPATH to used extra-libraries:
178 # bug #411789, http://hackage.haskell.org/trac/ghc/ticket/5743#comment:3
179 # make_setup -dynamic "$@" ||
189 make_setup -dynamic "$@" || make_setup "$@" || die "compiling ${setupmodule} failed" 180 make_setup "$@" || die "compiling ${setupmodule} failed"
190 else 181 else
191 make_setup "$@" || die "compiling ${setupmodule} failed" 182 make_setup "$@" || die "compiling ${setupmodule} failed"
192 fi 183 fi
193} 184}
194 185
202 fi 193 fi
203 194
204 rm -f "${setupdir}"/Setup.{lhs,hs} 195 rm -f "${setupdir}"/Setup.{lhs,hs}
205 196
206 echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \ 197 echo 'import Distribution.Simple; main = defaultMainWithHooks defaultUserHooks' \
207 > $setupdir/Setup.hs 198 > $setupdir/Setup.hs || die "failed to create default Setup.hs"
208} 199}
209 200
210cabal-hscolour() { 201cabal-hscolour() {
211 set -- hscolour "$@" 202 set -- hscolour "$@"
212 echo ./setup "$@" 203 echo ./setup "$@"
247 cabalconf="${cabalconf} --with-c2hs=${EPREFIX}/usr/bin/c2hs" 238 cabalconf="${cabalconf} --with-c2hs=${EPREFIX}/usr/bin/c2hs"
248 fi 239 fi
249 if [[ -n "${CABAL_USE_CPPHS}" ]]; then 240 if [[ -n "${CABAL_USE_CPPHS}" ]]; then
250 cabalconf="${cabalconf} --with-cpphs=${EPREFIX}/usr/bin/cpphs" 241 cabalconf="${cabalconf} --with-cpphs=${EPREFIX}/usr/bin/cpphs"
251 fi 242 fi
243
244 local option
245 for option in ${HCFLAGS}
246 do
247 cabalconf+=" --ghc-option=$option"
248 done
252 249
253 # Building GHCi libs on ppc64 causes "TOC overflow". 250 # Building GHCi libs on ppc64 causes "TOC overflow".
254 if use ppc64; then 251 if use ppc64; then
255 cabalconf="${cabalconf} --disable-library-for-ghci" 252 cabalconf="${cabalconf} --disable-library-for-ghci"
256 fi 253 fi
258 # currently cabal does not respect CFLAGS and LDFLAGS on it's own (bug #333217) 255 # currently cabal does not respect CFLAGS and LDFLAGS on it's own (bug #333217)
259 # so translate LDFLAGS to ghc parameters (without filtering) 256 # so translate LDFLAGS to ghc parameters (without filtering)
260 local flag 257 local flag
261 for flag in $LDFLAGS; do cabalconf="${cabalconf} --ghc-option=-optl$flag"; done 258 for flag in $LDFLAGS; do cabalconf="${cabalconf} --ghc-option=-optl$flag"; done
262 259
263 if version_is_at_least "1.4" "$(cabal-version)"; then
264 # disable executable stripping for the executables, as portage will 260 # disable executable stripping for the executables, as portage will
265 # strip by itself, and pre-stripping gives a QA warning. 261 # strip by itself, and pre-stripping gives a QA warning.
266 # cabal versions previous to 1.4 does not strip executables, and does 262 # cabal versions previous to 1.4 does not strip executables, and does
267 # not accept the flag. 263 # not accept the flag.
268 # this fixes numerous bugs, amongst them; 264 # this fixes numerous bugs, amongst them;
269 # bug #251881, bug #251882, bug #251884, bug #251886, bug #299494 265 # bug #251881, bug #251882, bug #251884, bug #251886, bug #299494
270 cabalconf="${cabalconf} --disable-executable-stripping" 266 cabalconf="${cabalconf} --disable-executable-stripping"
271 fi
272 267
273 if version_is_at_least "1.2.0" "$(cabal-version)"; then
274 cabalconf="${cabalconf} --docdir=${EPREFIX}/usr/share/doc/${PF}" 268 cabalconf="${cabalconf} --docdir=${EPREFIX}/usr/share/doc/${PF}"
275 # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes 269 # As of Cabal 1.2, configure is quite quiet. For diagnostic purposes
276 # it's better if the configure chatter is in the build logs: 270 # it's better if the configure chatter is in the build logs:
277 cabalconf="${cabalconf} --verbose" 271 cabalconf="${cabalconf} --verbose"
278 fi
279 # Note: with Cabal-1.1.6.x we do not have enough control
280 # to put the docs into the right place. They're currently going
281 # into /usr/share/${P}/ghc-x.y/doc/
282 # rather than /usr/share/doc/${PF}/
283 # Because we can only set the datadir, not the docdir.
284 272
285 # We build shared version of our Cabal where ghc ships it's shared 273 # We build shared version of our Cabal where ghc ships it's shared
286 # version of it. We will link ./setup as dynamic binary againt Cabal later. 274 # version of it. We will link ./setup as dynamic binary againt Cabal later.
287 [[ ${CATEGORY}/${PN} == "dev-haskell/cabal" ]] && \ 275 [[ ${CATEGORY}/${PN} == "dev-haskell/cabal" ]] && \
288 $(ghc-supports-shared-libraries) && \ 276 $(ghc-supports-shared-libraries) && \
305 ./setup "$@" || die "setup configure failed" 293 ./setup "$@" || die "setup configure failed"
306} 294}
307 295
308cabal-build() { 296cabal-build() {
309 unset LANG LC_ALL LC_MESSAGES 297 unset LANG LC_ALL LC_MESSAGES
310 set -- build "$@" 298 set -- build ${CABAL_EXTRA_BUILD_FLAGS} "$@"
311 echo ./setup "$@" 299 echo ./setup "$@"
312 ./setup "$@" \ 300 ./setup "$@" \
313 || die "setup build failed" 301 || die "setup build failed"
314} 302}
315 303
321 ./setup "$@" || die "setup copy failed" 309 ./setup "$@" || die "setup copy failed"
322 310
323 # cabal is a bit eager about creating dirs, 311 # cabal is a bit eager about creating dirs,
324 # so remove them if they are empty 312 # so remove them if they are empty
325 rmdir "${ED}/usr/bin" 2> /dev/null 313 rmdir "${ED}/usr/bin" 2> /dev/null
326
327 # GHC 6.4 has a bug in get/setPermission and Cabal 1.1.1 has
328 # no workaround.
329 # set the +x permission on executables
330 if [[ -d "${ED}/usr/bin" ]] ; then
331 chmod +x "${ED}/usr/bin/"*
332 fi
333 # TODO: do we still need this?
334} 314}
335 315
336cabal-pkg() { 316cabal-pkg() {
337 # This does not actually register since we're using true instead 317 # This does not actually register since we're using true instead
338 # of ghc-pkg. So it just leaves the .installed-pkg-config and we can 318 # of ghc-pkg. So it just leaves the .conf file and we can
339 # register that ourselves (if it exists). 319 # register that ourselves (if it exists).
340 local result
341 local err
342 320
343 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then 321 if [[ -n ${CABAL_HAS_LIBRARIES} ]]; then
344 if version_is_at_least "1.2.0" "$(cabal-version)"; then
345 # Newer cabal can generate a package conf for us: 322 # Newer cabal can generate a package conf for us:
346 ./setup register --gen-pkg-config="${T}/${P}.conf" 323 ./setup register --gen-pkg-config="${T}/${P}.conf"
347 ghc-setup-pkg "${T}/${P}.conf" 324 ghc-setup-pkg "${T}/${P}.conf"
348 ghc-install-pkg 325 ghc-install-pkg
349 else
350 # With older cabal we have to hack it by replacing its ghc-pkg
351 # with true and then just picking up the .installed-pkg-config
352 # file and registering that ourselves (if it exists).
353 sed -i "s|$(ghc-getghcpkg)|$(type -P true)|" .setup-config
354 ./setup register || die "setup register failed"
355 if [[ -f .installed-pkg-config ]]; then
356 ghc-setup-pkg .installed-pkg-config
357 ghc-install-pkg
358 else
359 die "setup register has not generated a package configuration file"
360 fi
361 fi
362 fi 326 fi
363} 327}
364 328
365# Some cabal libs are bundled along with some versions of ghc 329# Some cabal libs are bundled along with some versions of ghc
366# eg filepath-1.0 comes with ghc-6.6.1 330# eg filepath-1.0 comes with ghc-6.6.1
378} 342}
379 343
380# exported function: check if cabal is correctly installed for 344# exported function: check if cabal is correctly installed for
381# the currently active ghc (we cannot guarantee this with portage) 345# the currently active ghc (we cannot guarantee this with portage)
382haskell-cabal_pkg_setup() { 346haskell-cabal_pkg_setup() {
383 ghc-package_pkg_setup
384 if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]] && ! ghc-sanecabal "${CABAL_MIN_VERSION}"; then 347 if [[ -z "${CABAL_BOOTSTRAP}" && -z "${CABAL_FROM_GHC}" ]] && ! ghc-sanecabal "${CABAL_MIN_VERSION}"; then
385 eerror "The package dev-haskell/cabal is not correctly installed for" 348 eerror "The package dev-haskell/cabal is not correctly installed for"
386 eerror "the currently active version of ghc ($(ghc-version)). Please" 349 eerror "the currently active version of ghc ($(ghc-version)). Please"
387 eerror "run ghc-updater or haskell-updater or re-build dev-haskell/cabal." 350 eerror "run haskell-updater or re-build dev-haskell/cabal."
388 die "cabal is not correctly installed" 351 die "cabal is not correctly installed"
389 fi 352 fi
390 if [[ -z "${CABAL_HAS_BINARIES}" ]] && [[ -z "${CABAL_HAS_LIBRARIES}" ]]; then 353 if [[ -z "${CABAL_HAS_BINARIES}" ]] && [[ -z "${CABAL_HAS_LIBRARIES}" ]]; then
391 eerror "QA: Neither bin nor lib are in CABAL_FEATURES." 354 eqawarn "QA Notice: Neither bin nor lib are in CABAL_FEATURES."
392 fi 355 fi
393 if [[ -n "${CABAL_UNKNOWN}" ]]; then 356 if [[ -n "${CABAL_UNKNOWN}" ]]; then
394 ewarn "Unknown entry in CABAL_FEATURES: ${CABAL_UNKNOWN}" 357 eqawarn "QA Notice: Unknown entry in CABAL_FEATURES: ${CABAL_UNKNOWN}"
395 fi 358 fi
396 if cabal-is-dummy-lib; then 359 if cabal-is-dummy-lib; then
397 einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install." 360 einfo "${P} is included in ghc-${CABAL_CORE_LIB_GHC_PV}, nothing to install."
398 fi 361 fi
399} 362}
400 363
401haskell-cabal_src_configure() { 364haskell-cabal_src_configure() {
402 if ! cabal-is-dummy-lib; then 365 cabal-is-dummy-lib && return
366
403 pushd "${S}" > /dev/null 367 pushd "${S}" > /dev/null
404 368
405 cabal-bootstrap 369 cabal-bootstrap
406 370
407 cabal-configure $ghc_flags "$@" 371 cabal-configure "$@"
408 372
409 popd > /dev/null 373 popd > /dev/null
410 fi
411} 374}
412 375
413# exported function: nice alias 376# exported function: nice alias
414cabal_src_configure() { 377cabal_src_configure() {
415 haskell-cabal_src_configure "$@" 378 haskell-cabal_src_configure "$@"
422 # Such error leads to default src_configure and we lose all passed flags. 385 # Such error leads to default src_configure and we lose all passed flags.
423 if ! has "${EAPI:-0}" 0 1; then 386 if ! has "${EAPI:-0}" 0 1; then
424 local passed_flag 387 local passed_flag
425 for passed_flag in "$@"; do 388 for passed_flag in "$@"; do
426 [[ ${passed_flag} == --flags=* ]] && \ 389 [[ ${passed_flag} == --flags=* ]] && \
427 eqawarn "Cabal option '${passed_flag}' has effect only in src_configure()" 390 eqawarn "QA Notice: Cabal option '${passed_flag}' has effect only in src_configure()"
428 done 391 done
429 fi 392 fi
430 393
431 if ! cabal-is-dummy-lib; then 394 cabal-is-dummy-lib && return
395
432 has src_configure ${HASKELL_CABAL_EXPF} || haskell-cabal_src_configure "$@" 396 has src_configure ${HASKELL_CABAL_EXPF} || haskell-cabal_src_configure "$@"
433 cabal-build 397 cabal-build
434 398
435 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then 399 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
436 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then 400 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
437 # hscolour and haddock 401 # hscolour and haddock
438 cabal-hscolour-haddock 402 cabal-hscolour-haddock
439 else
440 # just haddock
441 cabal-haddock
442 fi
443 else 403 else
404 # just haddock
405 cabal-haddock
406 fi
407 else
444 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then 408 if [[ -n "${CABAL_USE_HSCOLOUR}" ]] && use hscolour; then
445 # just hscolour 409 # just hscolour
446 cabal-hscolour 410 cabal-hscolour
447 fi
448 fi 411 fi
449 fi 412 fi
450} 413}
451 414
452haskell-cabal_src_compile() { 415haskell-cabal_src_compile() {
474 437
475# exported function: cabal-style copy and register 438# exported function: cabal-style copy and register
476cabal_src_install() { 439cabal_src_install() {
477 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX= 440 has "${EAPI:-0}" 0 1 2 && ! use prefix && EPREFIX=
478 441
479 if cabal-is-dummy-lib; then 442 if ! cabal-is-dummy-lib; then
480 # create a dummy local package conf file for the sake of ghc-updater
481 local ghc_confdir_with_prefix="$(ghc-confdir)"
482 # remove EPREFIX
483 dodir ${ghc_confdir_with_prefix#${EPREFIX}}
484 echo '[]' > "${D}/$(ghc-confdir)/$(ghc-localpkgconf)"
485 else
486 cabal-copy 443 cabal-copy
487 cabal-pkg 444 cabal-pkg
488
489 if [[ -n "${CABAL_USE_HADDOCK}" ]] && use doc; then
490 if ! version_is_at_least "1.1.6" "$(cabal-version)"; then
491 dohtml -r dist/doc/html/*
492 fi
493 fi 445 fi
494 fi 446
447 # create a dummy local package conf file for haskell-updater
448 # if it does not exist (dummy libraries and binaries w/o libraries)
449 local ghc_confdir_with_prefix="$(ghc-confdir)"
450 # remove EPREFIX
451 dodir ${ghc_confdir_with_prefix#${EPREFIX}}
452 local conf_file="${D}/$(ghc-confdir)/$(ghc-localpkgconf)"
453 [[ -e $conf_file ]] || echo '[]' > "$conf_file" || die
495} 454}
496 455
497haskell-cabal_src_install() { 456haskell-cabal_src_install() {
498 pushd "${S}" > /dev/null 457 pushd "${S}" > /dev/null
499 458

Legend:
Removed from v.1.26  
changed lines
  Added in v.1.30

  ViewVC Help
Powered by ViewVC 1.1.20